#include "Graph.h"

template boolean contains(Vector<class T>)
void Graph::addVerge(Verge* v)
{
  m_verges.push_back(v);
}

void Graph::addEdge(Edge* e)
{
  //look if verges exist
  if (!(contains(m_verges,e->getVerge1()) || 
	contains(m_verges,e->getVerge2())))
    throw new VException("verge does not exists!",e);
  m_edges.push_back(edge);
  //save edge also inside each verge
  ((e->getVerge1())->m_edges).push_back(e);
  ((e->getVerge2())->m_edges).push_back(e);
}

void Graph::removeEdge(iterator it)
{
  Edge* e=(*it);
  Verge* v1=e->getVerge1();
  iterator itv;
  //erase this edge in both Verges
  for (itv=v1->edgeBegin();itv!=v1->edgeEnd();itv++)
  {
    if ((*itv)==e) (v1->m_edges).erase(itv);
  }
  for (itv=v2->edgeBegin();itv!=v2->edgeEnd();itv++)
  {
    if ((*itv)==e) (v2->m_edges).erase(itv);
  }
  //erase this edge in the edges list
  m_edges.erase(it);
}
  
}

void Graph::removeVerge(iterator it)
{
  iterator it2=m_edges.begin();
  Edge e;
  while (it2!=m_edges.end())
  {
    e=(*it2);
    if (e->getVerge1==(*it)) throw 
			       new VException("Cannot delete Verge if "
					      "there exists an edge with"
					      "that verge!",(*it));
  }
}
    
  
  
